{
    "uri": "{{ api_management_settings.stellio_api_path }}*",
    "name": "{{ api_management_settings.stellio_api_name }} Read",
    "desc": "{{ api_management_settings.stellio_api_description }}",
    "methods": [
      "GET"
    ],
    "plugins": {
      "prometheus": {
        "_meta": {
          "disable": false
        },
        "prefer_name": true
      },
      "loki-logger": {
        "batch_max_size": 1000,
        "buffer_duration": 60,
        "endpoint_addrs": [
          "http://loki.{{ api_management_settings.plugins.loki_logger.ns }}:3100"
        ],
        "endpoint_uri": "/loki/api/v1/push",
        "inactive_timeout": 5,
        "include_req_body": true,
        "include_resp_body": true,
        "keepalive": true,
        "keepalive_pool": 5,
        "keepalive_timeout": 60000,
        "log_labels": {
          "job": "{{ api_management_settings.plugins.loki_logger.job_label }}",
          "upstream": "{{ api_management_settings.stellio_api_loki_logger_label }}",
          "route": "{{api_management_settings.stellio_api_loki_logger_label}}_read",
        },
        "max_retry_count": 0,
        "name": "loki logger",
        "retry_delay": 1,
        "ssl_verify": false,
        "tenant_id": "fake",
        "timeout": 3000
      },
      "openid-connect": {
        "_meta": {
          "disable": false
        },
        "bearer_only": true,
        "client_id": "{{ IDM_CLIENT.API_ACCESS }}",
        "client_secret": "{{ api_access_client_secret }}",
        "discovery": "https://idm.{{ DOMAIN }}/auth/realms/{{ inv_idm.keycloak.realm_name }}/.well-known/openid-configuration",
        "introspection_endpoint": "https://idm.{{ DOMAIN }}/auth/realms/{{ inv_idm.keycloak.realm_name }}/protocol/openid-connect/token/introspect",
        "introspection_endpoint_auth_method": "post",
        "realm": "{{ inv_idm.keycloak.realm_name }}",
        "required_scopes": [
          "api:read"
        ]
      },
      "proxy-rewrite": {
        "regex_uri": [
          "{{ api_management_settings.stellio_api_path }}",
          "/"
        ]
      },
      "serverless-pre-function": {
        "_meta": {
          "disable": false
        },
        "functions": [
          "return function()      local jwt = require(\"resty.jwt\")      local headers = ngx.req.get_headers()     local ngsild_tenant = headers[\"NGSILD-Tenant\"]     if not ngsild_tenant then         ngsild_tenant = \"default_dataspace\"         ngx.req.set_header(\"NGSILD-Tenant\", \"default_dataspace\")     end      local auth_header = headers[\"Authorization\"]     if not auth_header then         ngx.log(ngx.ERR, 'Authorization header not found')         ngx.status = ngx.HTTP_UNAUTHORIZED          ngx.say('Authorization header not found')         return ngx.exit(ngx.HTTP_UNAUTHORIZED)     end      local _, jwt_token = auth_header:match('(%w+)[%s](.+)')      if not jwt_token then         ngx.log(ngx.ERR, 'JWT token not found in Authorization header')         ngx.status = ngx.HTTP_UNAUTHORIZED         ngx.say('JWT token not found in Authorization header')         return ngx.exit(ngx.HTTP_UNAUTHORIZED)     end      local jwt_obj, err = jwt:load_jwt(jwt_token)      if err then         ngx.log(ngx.ERR, 'Failed to load JWT token: ', err)         ngx.status = ngx.HTTP_UNAUTHORIZED         ngx.say('Failed to load JWT token: ', err)         return ngx.exit(ngx.HTTP_UNAUTHORIZED)     end      local jwt_payload = jwt_obj[\"payload\"]      if not jwt_payload or not jwt_payload[\"tenants\"] then         ngx.log(ngx.ERR, 'Required field \"tenants\" not found in JWT payload')         ngx.status = ngx.HTTP_UNAUTHORIZED         ngx.say('Required field \"tenants\" not found in JWT payload')          return ngx.exit(ngx.HTTP_UNAUTHORIZED)     end      for _, dataspace in ipairs(jwt_payload[\"tenants\"]) do         if dataspace.name == ngsild_tenant then             return         end     end      ngx.log(ngx.ERR, 'User does not have access to the tenant: ', ngsild_tenant)     ngx.say('User does not have access to the tenant: ', ngsild_tenant)     ngx.status = ngx.HTTP_UNAUTHORIZED      return ngx.exit(ngx.HTTP_UNAUTHORIZED) end"
        ],
        "phase": "access"
      }
    },
    "upstream_id": "{{ stellio_upstream_id }}",
    "status": 1
  }